unit Demodde;
{ Regressi Client pour recevoir les donnes de l'acquisition }

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Controls,
  Forms, Dialogs, StdCtrls, DdeMan, ExtCtrls, FileCtrl, iniFiles, demomain, constReg;

type
  TFormDDE = class(TForm)
    ClientDDE: TDdeClientConv;
    ClientItem: TDdeClientItem;
    ServeurDDE: TDdeServerConv;
    Donnees: TMemo;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ExecuteMacro(Sender: TObject; Msg: TStrings);
    procedure ClientDDEClose(Sender: TObject);
  private
    RegressiName : string;
    procedure OpenDDE;
    procedure CloseDDE;
    procedure chargeConfig(NomFichier : string);
    procedure sauveConfig(NomFichier : string);
    procedure AjouteConstante;
  public
      LienEtabli : boolean; { DDE OK }
      procedure Execute(Ordre : string);
      procedure EnvoieDonnees;
  end;

var
  FormDDE: TFormDDE;

implementation

{$R *.DFM}

const crTab = #9;

procedure TFormDDE.AjouteConstante;
var valeurConst : extended;
begin with ConstanteDlg do begin
     if NomConstEdit.text='' then exit;
     try
        ValeurConst := StrToFloat(ValeurConstEdit.text);
        Donnees.Lines.Add('');
        Donnees.Lines.Add(NomConstEdit.text+crTab);
        Donnees.Lines.Add(UniteConstEdit.text+crTab);
        Donnees.Lines.Add(FloatToStrF(valeurConst,ffGeneral,5,2)+crTab);
     except
     end;
end end;

procedure TFormDDE.OpenDDE;
begin
     ClientDDE.SetLink('Regressi','ServeurDDE');
     ClientItem.DDEItem := 'ServeurItem';
     LienEtabli := ClientDDE.OpenLink;
     if not LienEtabli then ShowMessage('Impossible de lancer Regressi');
end;

procedure TFormDDE.CloseDDE;
begin
     ClientDDE.CloseLink;
     LienEtabli := false;
end;

procedure TFormDDE.Execute(Ordre : string);
var Buf: PChar;
begin
     if not LienEtabli then OpenDDE;
     if not LienEtabli then exit;
     Buf := StrAlloc(Succ(Length(Ordre)));
     if not ClientDDE.ExecuteMacro(StrPCopy(Buf,Ordre), false) then begin
         ShowMessage(Ordre+' non excut');
         LienEtabli := false;
     end;
     StrDispose(Buf)
end;

procedure TFormDDE.FormDestroy(Sender: TObject);
begin
     ClientDDE.CloseLink
end;

procedure TFormDDE.EnvoieDonnees;
var i : integer;
    ligne : string;
    zero,coeff : single;
begin with Donnees.Lines do begin
     Clear;
(*     Add(Application.ExeName);*)
     Add('D:\WINGTS\win-gts.exe');
(*     if ConstanteDlg.NewPageCB.itemIndex=0
        then Add('Dmonstration communication')
        else Add('');*)
     Add(' (y=f(x) / srie 1 le 12/11/97 21:44:29)');
(*     Donnees.Lines.Add(ConstanteDlg.EditComm.text);*)
     ligne := 'E'+crTab+'U';
     Add(ligne);
     ligne := 'W/m'+crTab+'V';
     Add(ligne);
(*     ligne := 'temps'+crTab+'tension';
     Add(ligne);*)
     Coeff := random;
     Zero := random;
     for i := 0 to 100 do begin
         ligne := FloatToStrF(i*0.01,ffGeneral,5,2)+crTab+
             FloatToStrF(i*i*coeff*0.1+zero,ffGeneral,5,2);
         Add(ligne);
     end;
     AjouteConstante;
     Donnees.SelectAll;
     Donnees.CopyToClipBoard;
     case ConstanteDlg.NewPageCB.itemIndex of
          0 : Execute('CLIP|LOAD');
          1 : Execute('CLIP|ADD');
          2 : Execute('CLIP|PLUS');
     end;
     ConstanteDlg.NewPageCB.itemIndex := 1;
end end;

procedure TFormDDE.FormCreate(Sender: TObject);
var Ini : TiniFile;
    winDirAzt : array[0..255] of char;
    winDir : string;
begin
    LienEtabli := false;
    GetWindowsDirectory(winDirAzt,sizeOf(WinDirAzt)-1);
    winDir := strPas(winDirAzt);
    if winDir[length(winDir)]<>'\' then  winDir := winDir+'\';
    Ini := TiniFile.create(Windir+'regressi.INI');
    RegressiName := Ini.ReadString('Regressi','Path','c:\regwin\regressi.exe');
    ClientDDE.ServiceApplication := RegressiName;
    Ini.Free;
end;

procedure TFormDDE.ExecuteMacro(Sender: TObject; Msg: TStrings);
var Fonction,NomFichier : string;
    ArgStart,ArgEnd : byte;
begin
     if (Msg.Count = 1) then begin
       try
       ArgStart := Pos('(',Msg[0]);
       ArgEnd := Pos(')',Msg[0]);
       if (ArgStart >= ArgEnd)
          then begin
             NomFichier := '';
             ArgStart := length(Msg[0])
          end
          else begin
             NomFichier := Copy(Msg[0], Succ(ArgStart), ArgEnd - Succ(ArgStart));
             dec(ArgStart);
          end;
       Fonction := Copy(Msg[0], 1, ArgStart);
       if CompareText('CONFIG|LOAD',Fonction) = 0 then begin
           ChargeConfig(NomFichier);
           exit
       end;
       if CompareText('CONFIG|SAVE',Fonction) = 0 then begin
           SauveConfig(NomFichier);
           exit
       end;
       if CompareText('FOCUS',Fonction) = 0 then begin
           ConstanteDlg.NewPageCB.itemIndex := 0;
           FormMain.setFocus;
           exit;
       end;
       if CompareText('GETDATA',Fonction) = 0 then begin
           with ConstanteDlg do begin
               ConstanteDlg.NewPageCB.itemIndex := 1;
               Donnees.clear;
               Donnees.PasteFromClipboard;
               if Donnees.Lines.count>1 then begin
                   NomConstEdit.text := Donnees.Lines[0];
                   UniteConstEdit.text := Donnees.Lines[1];
               end;
           end;
           postMessage(FormMain.Handle,WM_ACQ_REG,0,0);
           exit;
       end;
       MessageDlg('Fonction inconnue : ' + Msg[0], mtError, [mbOK], 0);
       except
            MessageDlg('Syntaxe Macro DDE : Fonction(Paramtre)', mtError, [mbOK], 0);
       end;
     end
     else MessageDlg('Un message  la fois SVP', mtError, [mbOk], 0);
end;

procedure TFormDDE.ChargeConfig(NomFichier : string);
begin
       if NomFichier='' then exit;
       NomFichier := ChangeFileExt(NomFichier,'.HM');
       showMessage(NomFichier+' charg');
end;

procedure TFormDDE.SauveConfig(NomFichier : string);
begin
       if NomFichier='' then exit;
       NomFichier := ChangeFileExt(NomFichier,'.HM');
       showMessage(NomFichier+' sauv');
end;


procedure TFormDDE.ClientDDEClose(Sender: TObject);
begin
     LienEtabli := false;
end;

end.
